//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpKeyExpDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpKeyExpDlg *PgpKeyExpDlg;
//---------------------------------------------------------------------------
bool __fastcall ExportOpenPGPKeys(TForm *Owner, TPGPbuffer *PublicKeys,
   TPGPbuffer *SecretKeys, AnsiString SelectedKeyId)
{
   int selpos=-1;
   AnsiString idtext8;
   PgpKeyExpDlg = new TPgpKeyExpDlg(Owner);
   TListBox *LB = PgpKeyExpDlg->ListBox1;
   CenterDialog(PgpKeyExpDlg,Owner);
   PgpKeyExpDlg->pdb = PublicKeys; PgpKeyExpDlg->pdb->rewind();
   PgpKeyExpDlg->sdb = SecretKeys; PgpKeyExpDlg->sdb->rewind();

   TPGPbuffer *key = new TPGPbuffer();
   while (key->CopyKeyFrom(PgpKeyExpDlg->pdb,REWIND))
   {
      idtext8 = key->idtext8;
      LB->Items->Add("0x"+idtext8+" "+key->firstuid);
      if (!SelectedKeyId.IsEmpty() && idtext8==SelectedKeyId)
      {
         selpos = LB->Items->Count-1;
         LB->Selected[selpos] = true;
      }
      key->clear();
   }
   delete key;

   LB->TopIndex = selpos;
   PgpKeyExpDlg->ExportBtn->Enabled = selpos>=0;
   PgpKeyExpDlg->ShowModal();
   delete PgpKeyExpDlg;
   return true;
}
//---------------------------------------------------------------------------
__fastcall TPgpKeyExpDlg::TPgpKeyExpDlg(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyExpDlg::SelBtnClick(TObject *Sender)
{
   for (int i=0; i<ListBox1->Items->Count; i++)
      ListBox1->Selected[i] = true;
   ExportBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyExpDlg::ClrBtnClick(TObject *Sender)
{
   for (int i=0; i<ListBox1->Items->Count; i++)
      ListBox1->Selected[i] = false;
   ExportBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyExpDlg::ListBox1Click(TObject *Sender)
{
   if (ListBox1->SelCount>0 && !ExportBtn->Enabled)
      ExportBtn->Enabled = true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpKeyExpDlg::KeyIdText8(int atpos)
{
   if (atpos<0 || atpos>=ListBox1->Items->Count) return "";
   return ListBox1->Items->Strings[atpos].SubString(3,8);
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyExpDlg::ExportBtnClick(TObject *Sender)
{
   AnsiString idtext8,cap=Caption; Caption = "Exporting...";
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Exporting...");
   AppProcessMessages();
   TStringList *keys = new TStringList();
   TStringList *secs = new TStringList();
   TPGPbuffer *pkt = new TPGPbuffer();
   TPGPbuffer *key = new TPGPbuffer();
   TPGPbuffer *exports = new TPGPbuffer();
   for (int i=0; i<ListBox1->Items->Count; i++)
   {
      if (!ListBox1->Selected[i]) continue;

      if (pdb->get(key,KeyIdText8(i)))
      {
         if (PrivateKeysBox->Checked) exports->copykeyfrom(key,!REWIND);
         else
         {
            while (pkt->copypacketfrom(key,REWIND))
            {
               if (TrustPacket(pkt->CTB)) continue;
               exports->copyfrom(pkt);
               pkt->clear();
            }
         }
      }
   }
   exports->getascii(keys);
   exports->clear();
   for (int i=0; i<ListBox1->Items->Count; i++)
   {
      if (!ListBox1->Selected[i]) continue;

      if (sdb->get(key,KeyIdText8(i)))
         exports->copykeyfrom(key,!REWIND);
   }
   exports->getascii(secs);
   keys->AddStrings(secs);
   delete exports;
   delete key;
   delete pkt;
   delete secs;

   if (ClipBtn->Checked) CopyToClipboard(keys);
   //else keys->SaveToFile(filename);
   Sleep(300);
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Ok!");
   Caption = cap;
}
//---------------------------------------------------------------------------