#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PopAccDlg.h"
#include "PopProfDlg.h"
#include "PopRetDlg.h"
#include "Global.h"
#include "helpdlgs.h"
//---------------------------------------------------------------------------
#pragma link "Grids"
#pragma link "Pop3Prot"
#pragma resource "*.dfm"
TPopAcctDlg *PopAcctDlg;
//---------------------------------------------------------------------------
__fastcall TPopAcctDlg::TPopAcctDlg(TComponent* Owner)
  : TForm(Owner)
{
   accts = new TStringList();
   MainForm = (TForm*)Owner;
   Application->OnHint = &ShowHint;
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TPopAcctDlg::~TPopAcctDlg()
{
   delete accts;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::ShowHint(TObject *Sender)
{
   MainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)Application->Hint.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::Set(int Index, AnsiString &token, AnsiString &value)
{
   TStringList *tmp = new TStringList();
   AnsiString item,tok,s = accts->Strings[Index];//.LowerCase();
   int i=0; while((tok=GetParam(i++,s,POPDATDIV))!="" && tok!="end=1")
      tmp->Add(tok);
   tmp->Values[token] = value;
   for (i=0; i<tmp->Count; i++)
      item += tmp->Strings[i]+POPDATDIV;
   accts->Strings[Index] = item+"end=1";
   modified = true;
   delete tmp;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPopAcctDlg::Get(int Index, AnsiString &token)
{
   TStringList *tmp = new TStringList();
   AnsiString item,tok,s=accts->Strings[Index];//.LowerCase();
   int i=0; while((tok=GetParam(i++,s,POPDATDIV))!="" && tok!="end=1")
      tmp->Add(tok);
   item = tmp->Values[token];
   delete tmp;
   return item;
}
//---------------------------------------------------------------------------
bool __fastcall TPopAcctDlg::Checked(int Index)
{
   return Get(Index,"checked")=="1";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPopAcctDlg::Account(int Index)
{
   return Get(Index,"account");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPopAcctDlg::Password(int Index)
{
   return Get(Index,"password");
}
//---------------------------------------------------------------------------
bool __fastcall TPopAcctDlg::Remember(int Index)
{
   return Get(Index,"remember")=="1";
}
//---------------------------------------------------------------------------
bool __fastcall TPopAcctDlg::Delete(int Index)
{
   return Get(Index,"delete")=="1";
}
//---------------------------------------------------------------------------
bool __fastcall TPopAcctDlg::PgpOnly(int Index)
{
   return Get(Index,"pgponly")=="1";
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::DrawCheck(TCanvas *Canvas, TRect &Rect, TColor Color)
{
   TColor color = Canvas->Pen->Color;
   Canvas->Pen->Color = Color;
   Canvas->MoveTo(Rect.Left+4,Rect.Top+8);
   Canvas->LineTo(Rect.Left+7,Rect.Top+11);
   Canvas->LineTo(Rect.Left+16,Rect.Top+2);
   Canvas->MoveTo(Rect.Left+4,Rect.Top+9);
   Canvas->LineTo(Rect.Left+7,Rect.Top+12);
   Canvas->LineTo(Rect.Left+16,Rect.Top+3);
   Canvas->Pen->Color = color;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsDrawItemCanvas(TCanvas *Canvas, int Index,
   TRect &Rect, TOwnerDrawState State)
{
//
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsDrawItem(TWinControl *Control, int Index,
  TRect &Rect, TOwnerDrawState State)
{
   TRect r=Rect;
   AnsiString text;
   TCanvas *canvas=Accts->Canvas;
   TColor clBr=canvas->Brush->Color;
   bool selected = State.Contains(odSelected);
   canvas->TextRect(Rect,Rect.Left,Rect.Top+1,text);

   if (Checked(Index))
       DrawCheck(canvas,Rect,selected?clWhite:clBlue);

   r.Left=29; r.Right=r.Left+3; r.Top+=7; r.Bottom=r.Top+3;
   canvas->Brush->Color = Remember(Index)? clRed:selected ? clHighlight:clWindow;
   canvas->FillRect(r);
   r.Left+=11; r.Right+=11;
   canvas->Brush->Color = Delete(Index)  ? clRed:selected ? clHighlight:clWindow;
   canvas->FillRect(r);
   r.Left+=11; r.Right+=11;
   canvas->Brush->Color = PgpOnly(Index) ? clRed:selected ? clHighlight:clWindow;
   canvas->FillRect(r);
   canvas->Brush->Color=clBr;

   Rect.Left=64;
   text = Account(Index);
   int p; if ((p=text.Pos(POPACCDIV))>0) text[p] = '@';
   canvas->TextRect(Rect,Rect.Left,Rect.Top,text);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsMouseDown(TObject *Sender, TMouseButton Button,
   TShiftState Shift, int X, int Y)
{
   LastMouse.x = X; LastMouse.y = Y;
   if (X>=69) return; // not an area for special processing

   int Index = Accts->ItemIndex;
   TRect r = Accts->ItemRect(Index);
   if (Y<r.Top || Y>r.Bottom) return; // not this row

   if (X>=0 && X<24)
   {
      Set(Index,"checked",Checked(Index)?"0":"1");
      r.Left=0; r.Right=23;
      modified = true;
   }
   else
   if (X>=24 && X<36)
   {
      if (Remember(Index))
      {
          if (MsgBoxHwnd(Handle,"Forget password now?","Password",MB_OKCANCEL)==IDOK)
          {
             Set(Index,"remember","0");
             Set(Index,"password","");
             modified = true;
          }
      }
      else
      {
         MsgBoxHwnd(Handle,"No password to remember!","Password",MB_OK);
         //EditBtn->Click();
      }
      r.Left=24; r.Right=35;
   }
   else
   if (X>=36 && X<48)
   {
      Set(Index,"delete",Delete(Index)?"0":"1");
      r.Left=36; r.Right=47;
      modified = true;
   }
   else
   if (X>=48 && X<60)
   {
      Set(Index,"pgponly",PgpOnly(Index)?"0":"1");
      r.Left=48; r.Right=59;
      modified = true;
   }
   // this handles rect differently than InvalidateItem
   InvalidateRect(Accts->Handle,&RECT(r),false);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::HeaderControl1DrawSection(
  THeaderControl *HeaderControl, THeaderSection *Section, const TRect &Rect,
  bool Pressed)
{
   TRect rect(Rect); rect.Top += 2;
   DrawCheck(HeaderControl->Canvas,rect,clBlack);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::PaintItem(int Index)
{
   TOwnerDrawState State;
   if (Accts->Selected[Index]) State << odSelected;
   TRect r=Accts->ItemRect(Index);
   AcctsDrawItemCanvas(Accts->Canvas,Index,r,State);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsKeyPress(TObject *Sender, char &Key)
{
   int Index=Accts->ItemIndex;
   if (Index>=0 && Key==' ')
   {
      Set(Index,"checked",Checked(Index)?"0":"1");
      TRect r=Accts->ItemRect(Index);
      r.Right = 23; r.Left++, r.Top++; r.Bottom--;
      InvalidateRect(Accts->Handle,&RECT(r),false);
      GetBtn->Enabled = CheckCount();
   }
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsClick(TObject *Sender)
{
   AcctUp->Enabled = Accts->Items->Count>1;
   AcctDn->Enabled = Accts->Items->Count>1;
   int Index = Accts->ItemIndex;
   DeleteBtn->Enabled = Index>=0;
   GetBtn->Enabled = CheckCount();
   EditBtn->Enabled = Index>=0;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::HeaderControl1SectionClick(THeaderControl *HeaderControl,
   THeaderSection *Section)
{
   if (Section->Text=="Check") AcctsKeyPress(NULL,' ');
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::SetLB(int ForCount)
{
   if (ForCount<1) ForCount = 1;
   if (ForCount>5) ForCount = 5;
   bool locked = LockWindowUpdate(Handle);
   Panel2->Height = HeaderControl1->Height+((Accts->ItemHeight+1)*(ForCount+1))-2;
   Label1->Top = Panel2->Top+Panel2->Height+8;
   Application->ProcessMessages();
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::NewBtnClick(TObject *Sender)
{
   AnsiString profile = NewAcctProfile(this);
   if (!profile.IsEmpty())
   {
      accts->Add(profile); SyncAccts();
      Accts->ItemIndex = Accts->Items->Count-1;
      //if (Accts->Count) Accts->ItemIndex = Accts->Count-1;
      InvalidateItem(-1);
      modified = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::EditBtnClick(TObject *Sender)
{
   int Index=Accts->ItemIndex; if (Index<0) return;
   AnsiString profile = EditAcctProfile(this,accts->Strings[Index]);
   if (!profile.IsEmpty())
   {
      accts->Strings[Index] = profile; SyncAccts();
      RECT r; SetRect(&r,0,0,Accts->Width,Accts->Height);
      InvalidateRect(Accts->Handle,&RECT(Accts->ClientRect),false);
      ActiveControl = Accts;
      modified = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::DeleteBtnClick(TObject *Sender)
{
   int Index=Accts->ItemIndex; if (Index<0) return;
   if (MsgBoxHwnd(Handle,"Delete '"+Account(Index)+"' ?\n\n Are you sure?","Delete Account",MB_OKCANCEL)==IDOK)
   {
      TOwnerDrawState state;
      accts->Delete(Index); SyncAccts();
//      SetLB(Accts->Items->Count);
      InvalidateItem(-1);
      modified = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::SyncAccts()
{
   // remove null lines from end of actual array (accts)
   if (accts->Count)
   {
      while (Accts->Items->Count && accts->Strings[accts->Count-1].Pos("checked")!=1)
         accts->Delete(accts->Count-1);
      // if Accts has more lines than accts, delete from Accts
      while (Accts->Items->Count && Accts->Items->Count > accts->Count)
         Accts->Items->Delete(0);
      // if accts has more lines than Accts, add to Accts
      while (Accts->Items->Count < accts->Count)
         Accts->Items->Add("");
   }
   SetLB(Accts->Items->Count);
   switch (accts->Count)
   {
      case 0:
         Label1->Caption = "You currently have no active Pop3 accounts. Click 'New' to create one.";
         AcctUp->Visible = false; AcctDn->Visible = false;
         break;
      case 1:
         Label1->Caption = "Toggle options by clicking the desired column. See Help for more information.";
         AcctUp->Visible = false; AcctDn->Visible = false;
         break;
      default:
         Label1->Caption = "Toggle options by clicking the desired column. See Help for more information.";
         AcctUp->Visible = true; AcctDn->Visible = true;
         break;
   }
   GetBtn->Enabled = CheckCount();
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::GetBtnClick(TObject *Sender)
{
   TStringList *tmp = new TStringList();
   for (int i=0; i<Accts->Items->Count; i++)
      if (accts->Strings[i].Pos("checked=1")>0)
         tmp->Add(accts->Strings[i]);

   if (tmp->Count>0)
      PopRetrieveMail(tmp,this,MainForm,GetEveryLast->Checked);
   else
   {
      MsgBoxHwnd(Handle,
         "No accounts are marked for retreive!",
         "QuickSilver",
          MB_OKCANCEL
      );
   }
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::PopGetThisItemClick(TObject *Sender)
{
   int Index=Accts->ItemIndex; if (Index<0) return;

   TStringList *tmp = new TStringList();
   tmp->Add(accts->Strings[Index]);
   PopRetrieveMail(tmp,this,MainForm,GetEveryLast->Checked);
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::PopupMenuPopup(TObject *Sender)
{
   int Count=CheckCount(),Index=Accts->ItemIndex;
   PopGetMailItem->Enabled = Count>0;
   PopGetThisItem->Enabled = Index>=0;
   PopToggleItem->Enabled = Index>=0;
   PopDeleteItem->Enabled = Index>=0;
   PopOpenItem->Enabled = Index>=0;
   if (Index>=0)
   {
      if (!Checked(Index)) PopToggleItem->Caption="Mark account";
      else PopToggleItem->Caption = "Un&mark account";
//      Accts->Invalidate();
   }
}
//---------------------------------------------------------------------------
int  __fastcall TPopAcctDlg::CheckCount()
{
   int c=0; for (int i=0; i<Accts->Items->Count; i++)
       if (accts->Strings[i].Pos("checked=1"))
          c++;
   return c;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::PopToggleItemClick(TObject *Sender)
{
   int Index=Accts->ItemIndex;
   Set(Index,"checked",Checked(Index)?"0":"1");
   PaintAccounts(Index,Index);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::PaintAccounts(int first, int last)
{
   RECT r;
   TRect Rect;
   TOwnerDrawState state;
   int Index=Accts->ItemIndex;
   if (last<0) last = Accts->Items->Count-1;
   for (int i=first; i<=last; i++)
   {
      Rect = Accts->ItemRect(i);
      if (i==first) { r.left=Rect.Left; r.top=Rect.Top; }
      if (i==Index) state << odSelected; else state >> odSelected;
      Accts->Canvas->Brush->Color = i==Index ? clHighlight:clWindow;
      Accts->Canvas->Pen->Color = clRed;//i==Index ? clWindow:clBlack;
      AcctsDrawItem(this,i,Rect,state);
   }
   r.right=Rect.Right; r.bottom=Rect.Bottom;
   InvalidateRect(Accts->Handle,&r,false);

}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::InvalidateItem(int Index)
{
   TRect r = Index>=0 ? Accts->ItemRect(Index):Accts->ClientRect;
   InvalidateRect(Accts->Handle,&RECT(r),false);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctDnClick(TObject *Sender)
{
   int Index=Accts->ItemIndex;
   if (Index<accts->Count-1)
   {
      accts->Add("");
      AnsiString s = accts->Strings[Index];
      accts->Delete(Index);
      accts->Insert(Index+1,s);
      accts->Delete(accts->Count-1);
      Accts->ItemIndex++;
      PaintAccounts(Index,Index+1);
   }
   else MyBeep(MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctUpClick(TObject *Sender)
{
   int Index=Accts->ItemIndex;
   if (Index>0)
   {
      AnsiString s = accts->Strings[Index];
      accts->Delete(Index);
      accts->Insert(Index-1,s);
      Accts->ItemIndex--;
      PaintAccounts(Index-1,Index);
   }
   else MyBeep(MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsDblClick(TObject *Sender)
{
   if (LastMouse.x>69) EditBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel && modified)
   {
      switch (MsgBoxHwnd(Handle,
         AnsiString("Your POP accounts have been modified.\n\n")+
         AnsiString("Save your changes?"),"QuickSilver",
         MB_YESNOCANCEL))
      {
         case IDCANCEL:
            CanClose = false;
            break;
         case IDYES:
            ModalResult = mrOk;
            break;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("POP3","POP3 Accounts And Features","POP3 Accounts Dialog",this);
}
//---------------------------------------------------------------------------
