//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
//#include <pgpEncode.h>
//#include <pgpoptionlist.h>
//#include <pgpPubTypes.h>
#include <pgpKeys.h>
#include <pgpErrors.h>
#include <pgpUtilities.h>
#include <pgpSDKPrefs.h>
#include <pgpFeatures.h>
#include "QSpgp6ver.h"
/*
* SDK API version
* example: 1.0.0 = 0x01000000
*   0x01000000   (16777216)   SDK 1.0.0   PGP550
*   0x02000000   (33554432)   SDK 1.1.0
*   0x02000010   (33554448)   SDK 1.1.1   PGP553
*   0x03000000   (50331648)   SDK 1.5.0   PGP600
*   0x03000010   (50331664)   SDK 1.5.1
*   0x03000020   (50331680)   SDK 1.5.2   PGP602
*   0x03001000   (50335744)   SDK 1.6.0
*   0x03002000   (50339840)   SDK 1.7.0   PGP650
*   0x03002010   (50339856)   SDK 1.7.1   PGP651,2,3
*/
USEUNIT("QSpgp6ver.cpp");
USERES("QSpgp6.res");
USELIB("pgp_sdk.lib");
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) bool __fastcall PGPqdkInit(HWND owner, HWND apphandle);
extern "C" __declspec(dllexport) char* __fastcall GetQdkLibVersion();
extern "C" __declspec(dllexport) char* __fastcall GetQdkLibName();

extern "C" __declspec(dllexport) bool __fastcall PGPqdkCopyCompatible5(HWND Owner,
   char *pubring, char *secring);
extern "C" __declspec(dllexport) bool __fastcall PGPqdkCopyCompat5(HWND owner,
   char *pubring, char *secring);
extern "C" __declspec(dllexport) bool __fastcall PGPqdkEnableKeys(HWND Owner,
   PGPKeySetRef keys, char *HexIDs);
extern "C" __declspec(dllexport) bool __fastcall PGPqdkDeleteKeys(HWND Owner,
   PGPKeySetRef keys, char *HexIDs);
extern "C" __declspec(dllexport) bool __fastcall PGPqdkImportKeys(HWND Owner,
   PGPKeySetRef keys, char *Asciis);
extern "C" __declspec(dllexport) char*__fastcall PGPqdkExportKeys(HWND Owner,
   PGPKeySetRef keys, char *HexIDS, PGPExportFormat &ExpFormat,
   bool IncludePrivates);
//extern "C" __declspec(dllexport) bool __fastcall PGPqdkAddKeysBack(HWND Owner,
//   char *AsciiBlock);
extern "C" __declspec(dllexport) UINT __fastcall PGPqdkSdkApiVersion();
extern "C" __declspec(dllexport) char*__fastcall PGPqdkPubringpkr();
extern "C" __declspec(dllexport) char*__fastcall PGPqdkSecringskr();
extern "C" __declspec(dllexport) void __fastcall PGPqdkCleanup();
bool __fastcall IsPgpError(PGPError err, char *errmsg);

HWND owner;
PGPError err;
PGPUInt32 apiversion;
PGPContextRef context;
TStringList *asciiblock;
char buffer[256],*pubringpkr,*secringskr;
#define DEFKEYS NULL
#define PRIVATES2 true
#define BASICFORMAT kPGPExportFormat_Basic
#define createflag kPGPKeyRingOpenFlags_Create
#define muteflag kPGPKeyRingOpenFlags_Mutable
#define noflags false
#define s(str) AnsiString(str)
#define sm(msg) ShowMessage(msg)
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  return 1;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
char* __fastcall GetQdkLibVersion()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall GetQdkLibName()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkCopyCompatible5(HWND Owner, char *pubring, char *secring)
{
   PGPExportFormat BasicFormat = kPGPExportFormat_Basic;
   PGPKeySetRef impkeys,defkeys,qskeys;
   PGPFileSpecRef pgpPubRef,pgpSecRef;
   // initialize data references
   pgpSecRef = kInvalidPGPFileSpecRef;
   pgpPubRef = kInvalidPGPFileSpecRef;
   defkeys = kInvalidPGPKeySetRef;
   impkeys = kInvalidPGPKeySetRef;
   qskeys = kInvalidPGPKeySetRef;
   owner = Owner;
   int len;

   // export keys in default keyrings
   TStringList *asciiblock = new TStringList();
   asciiblock->SetText(PGPqdkExportKeys(Owner,DEFKEYS,DEFKEYS,BasicFormat,PRIVATES2));
   if (IsPGPError(BasicFormat))
      goto exit;

   // import ascii armored keys
   len=asciiblock->Text.Length();
   err=PGPImportKeySet(context,&impkeys,
      PGPOInputBuffer(context,asciiblock->Text.c_str(),len),
      PGPOLastOption(context)
   );
   if (IsPgpError(err,"Failed to import keys!"))
      goto exit;

   // rebuild keyring trust
   err=PGPPropagateTrust(impkeys);
   if (IsPgpError(err,"Failed to propagate PGP key trust!"))
      goto exit;

   // get public filespec for copied files
   err=PGPNewFileSpecFromFullPath(context,pubring,&pgpPubRef);
   if (IsPgpError(err,"Failed to initialize public file spec!"))
      goto exit;

   // get secret filespec for copied files
   err=PGPNewFileSpecFromFullPath(context,secring,&pgpSecRef);
   if (IsPgpError(err,"Failed to initialize secret file spec!"))
      goto exit;

   // open destination keyring pair
   err=PGPOpenKeyRingPair(context,createflag|muteflag,pgpPubRef,pgpSecRef,&qskeys);
   if (IsPgpError(err,"Failed to open QuickSilver keyrings for copy!"))
      goto exit;

   // add the new keys to keyrings in memory
   err=PGPAddKeys(impkeys,qskeys);
   if (IsPgpError(err,"Failed to copy to QuickSilver keyrings!"))
      goto exit;

   // commit the changes to disk
   if (PGPKeySetNeedsCommit(qskeys)) err=PGPCommitKeyRingChanges(qskeys);
   if (IsPgpError(err,"Failed to commit QuickSilver keyring changes!"))
      goto exit;

exit:
   if (PGPFileSpecRefIsValid(pgpSecRef)) PGPFreeFileSpec(pgpSecRef);
   if (PGPFileSpecRefIsValid(pgpPubRef)) PGPFreeFileSpec(pgpPubRef);
   if (PGPKeySetRefIsValid(impkeys)) PGPFreeKeySet(impkeys);
   if (PGPKeySetRefIsValid(defkeys)) PGPFreeKeySet(defkeys);
   if (PGPKeySetRefIsValid(qskeys)) PGPFreeKeySet(qskeys);
   return IsntPGPError(err);
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkCopyCompat5(HWND Owner, char *pubring, char *secring)
{
   PGPKeySetRef impkeys,newkeys,defkeys;
   PGPFileSpecRef pgpPubRef,pgpSecRef;
   //void *data=NULL; PGPSize size;
   PGPExportFormat ExpFormat = kPGPExportFormat_Basic;
   AnsiString Pubring,Secring,sectemp,pubtemp;
   // initialize data references
   pgpSecRef = kInvalidPGPFileSpecRef;
   pgpPubRef = kInvalidPGPFileSpecRef;
   defkeys = kInvalidPGPKeySetRef;
   impkeys = kInvalidPGPKeySetRef;
   newkeys = kInvalidPGPKeySetRef;
   Pubring = pubring;
   pubtemp = Pubring+".tmp";
   Secring = secring;
   sectemp = Secring+".tmp";
   owner = Owner;

   // export keys in default keyrings
   TStringList *asciiblock = new TStringList();
   asciiblock->SetText(PGPqdkExportKeys(Owner,DEFKEYS,DEFKEYS,ExpFormat,PRIVATES2));
   if (IsPGPError(ExpFormat))
      goto exit;

   // delete temporary files, if present
   if (FileExists(sectemp)) DeleteFile(sectemp.c_str());
   if (FileExists(pubtemp)) DeleteFile(pubtemp.c_str());

   // get public filespec for copied files
   err=PGPNewFileSpecFromFullPath(context,pubtemp.c_str(),&pgpPubRef);
   if (IsPgpError(err,"Failed to initialize public file spec!"))
      goto exit;

   // get secret filespec for copied files
   err=PGPNewFileSpecFromFullPath(context,sectemp.c_str(),&pgpSecRef);
   if (IsPgpError(err,"Failed to initialize secret file spec!"))
      goto exit;

   // open destination keyring pair
   err=PGPOpenKeyRingPair(context,createflag|muteflag,pgpPubRef,pgpSecRef,&newkeys);
   if (IsPgpError(err,"Failed to open QuickSilver keyrings for copy!"))
      goto exit;

   if (PGPqdkImportKeys(Owner,newkeys,asciiblock->Text.c_str()))
   {
      CopyFile(sectemp.c_str(),secring,false);
      CopyFile(pubtemp.c_str(),pubring,false);
   }

exit:
   //if (FileExists(sectemp)) DeleteFile(sectemp.c_str());
   //if (FileExists(pubtemp)) DeleteFile(pubtemp.c_str());
   if (PGPFileSpecRefIsValid(pgpSecRef)) PGPFreeFileSpec(pgpSecRef);
   if (PGPFileSpecRefIsValid(pgpPubRef)) PGPFreeFileSpec(pgpPubRef);
   if (PGPKeySetRefIsValid(newkeys)) PGPFreeKeySet(newkeys);
   if (PGPKeySetRefIsValid(impkeys)) PGPFreeKeySet(impkeys);
   if (PGPKeySetRefIsValid(defkeys)) PGPFreeKeySet(defkeys);
   //if (data) PGPFreeData(data);
   return IsntPGPError(err);
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkImportKeys(HWND Owner, PGPKeySetRef keys, char *asckeys)
{
   PGPKeySetRef impkeys,defkeys;
   defkeys = kInvalidPGPKeySetRef;
   impkeys = kInvalidPGPKeySetRef;
   owner = Owner;

   if (!keys)
   {
      // open default keyrings
      err=PGPOpenDefaultKeyRings(context,createflag|muteflag,&defkeys);
      if (IsPgpError(err,"Failed to open default keyrings!"))
         goto exit;

      keys = defkeys;
   }

   // import ascii armored keys
   err=PGPImportKeySet(context,&impkeys,
      PGPOInputBuffer(context,asckeys,strlen(asckeys)),
      PGPOLastOption(context)
   );
   if (IsPgpError(err,"Failed to import PGP keys!"))
      goto exit;

   // add the new keys to keyrings in memory
   err=PGPAddKeys(impkeys,keys);
   if (IsPgpError(err,"Failed to copy to QuickSilver keyrings!"))
      goto exit;

   // commit the changes to disk
   if (PGPKeySetNeedsCommit(keys)) err=PGPCommitKeyRingChanges(keys);
   if (IsPgpError(err,s(
         s("Failed to commit QuickSilver keyring changes!\n\n")+
         s("More than likely you have your main PGPkeys program is\n")+
         s("running. If this is the case, close PGP now and try again\n")).c_str()
      ))
      goto exit;

exit:
   if (PGPKeySetRefIsValid(impkeys)) PGPFreeKeySet(impkeys);
   if (PGPKeySetRefIsValid(defkeys)) PGPFreeKeySet(defkeys);
   return IsntPGPError(err);
}
//---------------------------------------------------------------------------
char*__fastcall PGPqdkExportKeys(HWND Owner, PGPKeySetRef keys, char *HexIDs,
   PGPExportFormat &ExportFormat, bool IncludePrivates)
{
   TStringList *hexids = new TStringList();
   hexids->SetText(HexIDs);
   asciiblock->Clear();

   AnsiString hexid;
   void *data=NULL; PGPSize size;
   PGPKeyRef key = kInvalidPGPKeyRef;
   PGPKeySetRef expkeys,defkeys,singkey;//,usekeys=keys;
   defkeys = kInvalidPGPKeySetRef;
   expkeys = kInvalidPGPKeySetRef;
   singkey = kInvalidPGPKeySetRef;
   PGPKeyID keyid;
   owner = Owner;
   int i=0;

   if (keys==NULL)
   {
      // open default keyrings
      err=PGPOpenDefaultKeyRings(context,noflags,&defkeys);
      if (IsPgpError(err,"Failed to open default keyrings!"))
         goto exit;

      keys = defkeys;
   }

   err=PGPNewEmptyKeySet(keys,&expkeys);
   if (IsPgpError(err,"Failed to initialize export keyset!"))
      goto exit;

   while(i<hexids->Count)
   {
      hexid=hexids->Strings[i];
      if (hexid.Trim().IsEmpty()) continue;

      // transfer my hexid to a PGPKeyID
      err=PGPGetKeyIDFromString(hexid.c_str(), &keyid);
      if (IsPgpError(err,"Unable to initialize Key Id!"))
         goto exit;

      // get the key for given hexid
      err=PGPGetKeyByKeyID(keys,&keyid,kPGPPublicKeyAlgorithm_Invalid,&key);
      if (IsPgpError(err,s("Unable to get pgp key 0x"+s(hexid)+"!").c_str()))
         goto exit;

      // place key in singleton keyset
      err=PGPNewSingletonKeySet(key,&singkey);
      if (IsPgpError(err,s("Unable to create singleton keyset for 0x"+s(hexid)+"!").c_str()))
         goto exit;

      // do the job, add the key
      err=PGPAddKeys(singkey,expkeys);
      if (IsPgpError(err,s("Unable to add key 0x"+hexid+" to export keyset!").c_str()))
         goto exit;

      // free singkey
      if (PGPKeySetRefIsValid(singkey)) PGPFreeKeySet(singkey);
      singkey = kInvalidPGPKeySetRef;
      i++;
   }

   // export keys with privates
   err=PGPExportKeySet(i ? expkeys : keys, // if no expkey export defkeys
      PGPOAllocatedOutputBuffer(context,&data,-1,&size), // -1 = no size restraint
      PGPOExportFormat(context,ExportFormat),
      PGPOExportPrivateKeys(context,IncludePrivates),
      PGPOVersionString(context,"N/A"),
      PGPOLastOption(context)
   );
   if (IsPgpError(err,"Failed to export keys!"))
     goto exit;

   asciiblock->SetText((char*)data);
exit:
   if (PGPKeySetRefIsValid(singkey)) PGPFreeKeySet(singkey);
   if (PGPKeySetRefIsValid(expkeys)) PGPFreeKeySet(expkeys);
   if (PGPKeySetRefIsValid(defkeys)) PGPFreeKeySet(defkeys);
   if (data) PGPFreeData(data);
   delete hexids;
   ExportFormat = (PGPExportFormat)err;
   return asciiblock->Text.c_str();
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkDeleteKeys(HWND Owner, PGPKeySetRef keys, char *HexIDs)
{
   TStringList *hexids = new TStringList();
   hexids->SetText(HexIDs);

   int i = 0;
   owner = Owner;
   AnsiString hexid;
   PGPKeyRef key = kInvalidPGPKeyRef;
   PGPKeySetRef defkeys,zapkey;
   defkeys = kInvalidPGPKeySetRef;
   zapkey  = kInvalidPGPKeySetRef;
   PGPKeyID keyid;

   if (!keys)
   {
      // open default keyrings
      err=PGPOpenDefaultKeyRings(context,muteflag,&defkeys);
      if (IsPgpError(err,"Failed to open default keyrings!"))
         goto exit;

      keys = defkeys;
   }
   while(i<hexids->Count)
   {
      hexid=hexids->Strings[i];
      if (hexid.Trim().IsEmpty()) continue;

      // transfer my hexid to a PGPKeyID
      err=PGPGetKeyIDFromString(hexid.c_str(), &keyid);
      if (IsPgpError(err,"Unable to initialize Key Id!"))
         goto exit;

      // get the key for given hexid
      err=PGPGetKeyByKeyID(keys,&keyid,kPGPPublicKeyAlgorithm_Invalid,&key);
      if (IsPgpError(err,s("Unable to get pgp key: "+s(hexid)+"!").c_str()))
         goto exit;

      // place key in singleton keyset
      err=PGPNewSingletonKeySet(key,&zapkey);
      if (IsPgpError(err,s("Unable to create singleton keyset for: "+s(hexid)+"!").c_str()))
         goto exit;

      // do the job, delete the key
      err=PGPRemoveKeys(zapkey,keys);
      if (IsPgpError(err,s("Unable to delete key: "+hexid+"!").c_str()))
         goto exit;

      // free zapkey
      if (PGPKeySetRefIsValid(zapkey)) PGPFreeKeySet(zapkey);
      zapkey = kInvalidPGPKeySetRef;

      i++;
   }

   // commit the changes to disk
   if (PGPKeySetNeedsCommit(keys)) err=PGPCommitKeyRingChanges(keys);
   if (IsPgpError(err,s(
         s("Failed to commit QuickSilver keyring changes!\n\n")+
         s("More than likely you have your main PGPkeys program is\n")+
         s("running. If this is the case, close PGP now and try again\n")).c_str()
      ))
      goto exit;

exit:
   if (PGPKeySetRefIsValid(defkeys)) PGPFreeKeySet(defkeys);
   if (PGPKeySetRefIsValid(zapkey)) PGPFreeKeySet(zapkey);
   key = kInvalidPGPKeyRef;
   delete hexids;
   return IsntPGPError(err);
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkEnableKeys(HWND Owner, PGPKeySetRef keys, char *HexIDs)
{
   TStringList *hexids = new TStringList();
   hexids->SetText(HexIDs);

   int i = 0;
   owner = Owner;
   AnsiString hexid,job;
   PGPKeyRef key = kInvalidPGPKeyRef;
   PGPKeySetRef defkeys = kInvalidPGPKeySetRef;
   PGPKeyID keyid;
   bool enable;

   if (!keys)
   {
      // open default keyrings
      err=PGPOpenDefaultKeyRings(context,muteflag,&defkeys);
      if (IsPgpError(err,"Failed to open default keyrings!"))
         goto exit;

      keys = defkeys;
   }
   while (i<hexids->Count)
   {
      hexid=hexids->Names[i];
      if (hexid.Trim().IsEmpty()) continue;
      enable = hexids->Values[hexid].ToIntDef(1);

      // transfer hexid to a PGPKeyID
      err=PGPGetKeyIDFromString(hexid.c_str(), &keyid);
      if (IsPgpError(err,"Unable to initialize Key Id!"))
         goto exit;

      // get the key for given hexid
      err=PGPGetKeyByKeyID(keys,&keyid,kPGPPublicKeyAlgorithm_Invalid,&key);
      if (IsPgpError(err,s("Unable to get pgp key: "+s(hexid)+" !").c_str()))
         goto exit;

      // do the job, enable or disable
      job=enable ? "en":"dis";

      err=enable ? PGPEnableKey(key) : PGPDisableKey(key);
      if (IsPgpError(err,s("Failed to "+job+"able pgp key: "+s(hexid)+" !").c_str()))
         goto exit;

      i++;
   }

   // commit the changes to disk
   if (PGPKeySetNeedsCommit(keys)) err=PGPCommitKeyRingChanges(keys);
   if (IsPgpError(err,s(
         s("Failed to commit QuickSilver keyring changes!\n\n")+
         s("More than likely you have your main PGPkeys program is\n")+
         s("running. If this is the case, close PGP now and try again\n")).c_str()
      ))
      goto exit;

exit:
   if (PGPKeySetRefIsValid(defkeys)) PGPFreeKeySet(defkeys);
   key = kInvalidPGPKeyRef;
   return IsntPGPError(err);
}
//---------------------------------------------------------------------------
//bool __fastcall PGPqdkAddKeysBack(HWND Owner, PGPKeySetRef keys, char *AsciiBlock)
//{
//}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkInit(HWND Owner, HWND apphandle)
{
   PGPFileSpecRef pubSpec = kInvalidPGPFileSpecRef;
   PGPFileSpecRef secSpec = kInvalidPGPFileSpecRef;
   Application->Handle = apphandle;
   asciiblock = new TStringList();
   owner = Owner;

   err=PGPsdkInit();
   if (IsPgpError(err,"Unable to initialize PGPsdk!"))
      return false;

   err=PGPNewContext(kPGPsdkAPIVersion,&context);
   if (IsPgpError(err,"Failed to initialize PGP context structure!"))
      return false;

   err=PGPsdkLoadDefaultPrefs(context);
   if (IsPgpError(err,"Unable to load PGPsdk default preferences!"))
      return false;

   // if first attempt fails, use prefSelector from earlier sdk version
   err=PGPsdkPrefGetFileSpec(context,(PGPsdkPrefSelector)5,&pubSpec);
   if (err==-12000) err=PGPsdkPrefGetFileSpec(context,(PGPsdkPrefSelector)0,&pubSpec);
   if (IsPgpError(err,"Unable to get PGP public keyring file spec!"))
      goto exit;

   err=PGPGetFullPathFromFileSpec(pubSpec,&pubringpkr);
   if (IsPgpError(err,"Unable to get PGP public keyring path!"))
      goto exit;

   // if first attempt fails, use prefSelector from earlier sdk version
   err=PGPsdkPrefGetFileSpec(context,(PGPsdkPrefSelector)6,&secSpec);
   if (err==-12000) err=PGPsdkPrefGetFileSpec(context,(PGPsdkPrefSelector)1,&secSpec);
   if (IsPgpError(err,"Unable to get PGP secret keyring file spec!"))
      goto exit;

   err=PGPGetFullPathFromFileSpec(secSpec,&secringskr);
   if (IsPgpError(err,"Unable to get PGP secret keyring path!"))
      goto exit;

   err=PGPGetSDKVersion(&apiversion);
   if (IsPgpError(err,"Failed to get PGPsdk API version!"))
      goto exit;

   StrLower(pubringpkr);
   StrLower(secringskr);

exit:
   if (PGPFileSpecRefIsValid(secSpec)) PGPFreeFileSpec(secSpec);
   if (PGPFileSpecRefIsValid(pubSpec)) PGPFreeFileSpec(pubSpec);
   return IsntPGPError(err);
}
//---------------------------------------------------------------------------
void __fastcall PGPqdkCleanup()
{
   delete asciiblock;
   if (secringskr) PGPFreeData(secringskr);
   if (pubringpkr) PGPFreeData(pubringpkr);
   if (PGPContextRefIsValid(context)) PGPFreeContext(context);
   PGPsdkCleanup();
}
//---------------------------------------------------------------------------
UINT __fastcall PGPqdkSdkApiVersion()
{
   return apiversion;
}
//---------------------------------------------------------------------------
char* __fastcall PGPqdkPubringpkr()
{
   return pubringpkr;
}
//---------------------------------------------------------------------------
char* __fastcall PGPqdkSecringskr()
{
   return secringskr;
}
//---------------------------------------------------------------------------
/*bool __fastcall PGPqdkCopyCompat5(HWND Owner, char *pubring, char *secring)
{
   PGPKeySetRef impkeys,newkeys,defkeys;
   PGPFileSpecRef pgpPubRef,pgpSecRef;
   void *data=NULL; PGPSize size;
   AnsiString Pubring,Secring,sectemp,pubtemp;
   // initialize data references
   pgpSecRef = kInvalidPGPFileSpecRef;
   pgpPubRef = kInvalidPGPFileSpecRef;
   defkeys = kInvalidPGPKeySetRef;
   impkeys = kInvalidPGPKeySetRef;
   newkeys = kInvalidPGPKeySetRef;
   Pubring = pubring;
   pubtemp = Pubring+".tmp";
   Secring = secring;
   sectemp = Secring+".tmp";
   owner = Owner;

   // open default keyrings
   err=PGPOpenDefaultKeyRings(context,noflags,&defkeys);
   if (IsPgpError(err,"Failed to open default keyrings!"))
      goto exit;

   // export default keys, compatmode with private keys
   err=PGPExportKeySet(defkeys,
      PGPOAllocatedOutputBuffer(context,&data,-1,&size), // -1 = no size restraint
      PGPOExportFormat(context,kPGPExportFormat_Basic),
      PGPOExportPrivateKeys(context,true),
      PGPOVersionString(context,"N/A"),
      PGPOLastOption(context)
   );
   if (IsPgpError(err,"Failed to export default keys!"))
     goto exit;

   // import keys exported above in compatible mode
   err=PGPImportKeySet(context,&impkeys,
      PGPOInputBuffer(context,data,size+1),
      PGPOLastOption(context)
   );
   if (IsPgpError(err,"Failed to import PGP5 compatible keyrings!"))
      goto exit;

   // delete temporary files, if present
   if (FileExists(sectemp)) DeleteFile(sectemp.c_str());
   if (FileExists(pubtemp)) DeleteFile(pubtemp.c_str());

   // get public filespec for copied files
   err=PGPNewFileSpecFromFullPath(context,pubtemp.c_str(),&pgpPubRef);
   if (IsPgpError(err,"Failed to initialize public file spec!"))
      goto exit;

   // get secret filespec for copied files
   err=PGPNewFileSpecFromFullPath(context,sectemp.c_str(),&pgpSecRef);
   if (IsPgpError(err,"Failed to initialize secret file spec!"))
      goto exit;

   // open destination keyring pair
   err=PGPOpenKeyRingPair(context,createflag|muteflag,pgpPubRef,pgpSecRef,&newkeys);
   if (IsPgpError(err,"Failed to open QuickSilver keyrings for copy!"))
      goto exit;

   // add the new keys to keyrings in memory
   err=PGPAddKeys(impkeys,newkeys);
   if (IsPgpError(err,"Failed to copy to QuickSilver keyrings!"))
      goto exit;

   // commit the changes to disk
   if (PGPKeySetNeedsCommit(newkeys)) err=PGPCommitKeyRingChanges(newkeys);
   if (IsPgpError(err,"Failed to commit QuickSilver keyring changes!"))
      goto exit;

   CopyFile(sectemp.c_str(),secring,false);
   CopyFile(pubtemp.c_str(),pubring,false);

exit:
   // tidy up successful or not
   //if (FileExists(sectemp)) DeleteFile(sectemp.c_str());
   //if (FileExists(pubtemp)) DeleteFile(pubtemp.c_str());
   if (PGPFileSpecRefIsValid(pgpSecRef)) PGPFreeFileSpec(pgpSecRef);
   if (PGPFileSpecRefIsValid(pgpPubRef)) PGPFreeFileSpec(pgpPubRef);
   if (PGPKeySetRefIsValid(newkeys)) PGPFreeKeySet(newkeys);
   if (PGPKeySetRefIsValid(impkeys)) PGPFreeKeySet(impkeys);
   if (PGPKeySetRefIsValid(defkeys)) PGPFreeKeySet(defkeys);
   if (data) PGPFreeData(data);
   return IsntPGPError(err);
}*/
//---------------------------------------------------------------------------
void __fastcall ShowPGPError(PGPError err, AnsiString errmsg)
{
	 if(IsPGPError(err))
   {
  	 char *buf = new char[256];
 	    PGPGetErrorString(err, 255, buf);
      MessageBox(owner,
         AnsiString(errmsg+"\nError: ("+s(err)+") "+s(buf)).c_str(),
        "PGP Error",
         MB_OK
      );
      delete buf;
   }
}
//---------------------------------------------------------------------------
bool __fastcall IsPgpError(PGPError err, char *errmsg)
{
   if (IsPGPError(err))
   {
      ShowPGPError(err,errmsg);
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
