//---------------------------------------------------------------------------
#ifndef TextWinsH
#define TextWinsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Buttons.hpp>
#include "explbtn.hpp"
//---------------------------------------------------------------------------
const AnsiString newNote = "New Note";
enum MsgType { tNewMessage,tMessage,tNewArticle,tArticle,tNewNote,tNote,tDraft,
   tTemplate,tInMessage,tChainLog };

class TTextWin : public TForm
{
__published:	// IDE-managed Components
  TPanel *Panel1;
  TRichEdit *Editor;
  TPopupMenu *PopupMenu;
  TMenuItem *PopCutItem;
  TMenuItem *PopUndoItem;
  TMenuItem *N4;
  TMenuItem *PopCopyItem;
  TMenuItem *PopPasteItem;
  TMenuItem *PopSelectAllItem;
  TMenuItem *PopPasteAsQuoteItem;
  TMenuItem *N5;
  TMenuItem *PopInsertFilenameItem;
  TMenuItem *PopInsertTextItem;
  TMenuItem *N6;
  TMenuItem *PopWordWrapItem;
  TBevel *Bevel6; 
  TBevel *Bevel1;
  TOfficeButton *OkBtn;
  TOfficeButton *CutBtn;
  TOfficeButton *CopyBtn;
  TOfficeButton *PasteBtn;
  TBevel *Bevel99;
  //void __fastcall EditMenuClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall OkBtnClick(TObject *Sender);
  void __fastcall FormActivate(TObject *Sender);
  void __fastcall FormDeactivate(TObject *Sender);
  void __fastcall EditorSelectionChange(TObject *Sender);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall FormPaint(TObject *Sender);
  void __fastcall EditorMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
  void __fastcall PopupMenuClick(TObject *Sender);
  void __fastcall ClipboardBtnClick(TObject *Sender);
private:	// User declarations
public:	// User declarations
  bool loading;
  MsgType Type;
  AnsiString DataKey,IndexStr;
  virtual __fastcall TTextWin(TComponent* Owner);
  void __fastcall SetText(AnsiString &Name, TStrings *Text);
  void __fastcall SetParentButtons(bool enable);
  virtual void __fastcall SetEditButtons(bool enable);
  void __fastcall PasteFromClipboardQuote();
  void __fastcall PasteFromClipboard();
  void __fastcall CutToClipboard();
  void __fastcall SetEditRect();
  virtual AnsiString __fastcall Name();
  virtual bool __fastcall CheckSave();
  virtual bool __fastcall SaveAs();
  virtual bool __fastcall Save();
  void __fastcall Print();
  void __fastcall ShowCurXY(bool DontClear);
  void __fastcall ShowStatus(AnsiString &msg);
  void virtual __fastcall WMMdiActivate(TMessage& Msg);
  void __fastcall GetUnWrappedText(TStrings *ToStrings);
  bool __fastcall InsertFileText();
  bool __fastcall InsertFileName();
  void __fastcall ToggleWordWrap();
  // message map
  BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(WM_MDIACTIVATE,TMessage,WMMdiActivate)
  END_MESSAGE_MAP(TForm)
};

//TTextWin* __fastcall NewTextWin(const AnsiString &Title, TStrings *Lines);
//---------------------------------------------------------------------------
extern TTextWin *TextWin;
//---------------------------------------------------------------------------
#endif
