//---------------------------------------------------------------------------
#ifndef pgpdbH
#define pgpdbH

#include "mixmaster.h"
#include "pgpkeywins.h"
//---------------------------------------------------------------------------
class TPgpDBKey : public TObject
{
private:
   int __fastcall GetMPI(BUFFER *mpi);
   int __fastcall PutMPI(BUFFER *buf, BUFFER *mpi);
public:
   int status;
   BUFFER *key;
   TPgpDBKey *pair;
   virtual __fastcall TPgpDBKey(BUFFER *BinKey);
   virtual __fastcall TPgpDBKey(TPgpDBKey *Key);
   virtual __fastcall TPgpDBKey(TStrings *AsciiKey);
   virtual __fastcall TPgpDBKey(TPGPbuffer *Key);
   __fastcall~TPgpDBKey();
   long __fastcall Write(TFileStream *Stream);
   int __fastcall KeyId(BUFFER *Keyid);
   AnsiString __fastcall Description();
   AnsiString __fastcall AsciiArmored();
   AnsiString __fastcall IdText8();
   AnsiString __fastcall KeyUserIdsRow();
   AnsiString __fastcall KeyUserIds(int pos=-1);
   AnsiString __fastcall Addresses();
   int  __fastcall Validity();
   int  __fastcall KeyBits();
   byte __fastcall Algorithm();
   byte __fastcall Version();
   long __fastcall TimeStamp();
   bool __fastcall IsPair();
   int  __fastcall Type();
   int  __fastcall CTB();
   // cyberpunk functions
   AnsiString __fastcall CpkAddress();
   AnsiString __fastcall CpkShort();
};

class TPgpDB : public TObject
{
public:
   int status;
   bool modified;
   TStringList *keys;
   bool allowduplicates;
   // constructors, destructor
   virtual __fastcall TPgpDB();
   virtual __fastcall TPgpDB(AnsiString KeyFile);
   virtual __fastcall TPgpDB(TStrings *AsciiKeys);
   virtual __fastcall~TPgpDB();
   // save methods
   TPgpDBKey* __fastcall GetKey(int Pos);
   void __fastcall SaveToFile(AnsiString &FileName, bool Armored=true);
   void __fastcall SaveToFileBak(AnsiString &FileName, int bakcopies, bool Armored=true);
   TStrings* __fastcall SaveToStringsPlus(TStrings *AsciiStrings);
   TStrings* __fastcall SaveToStrings(TStrings *AsciiStrings);
   BUFFER* __fastcall SaveToBuffer(BUFFER *BinBuf);
   AnsiString __fastcall SaveToString();
   // add methods
   virtual int __fastcall AddKey(BUFFER *KeyBuf);
   virtual int __fastcall AddKey(TPgpDBKey *Key);
   virtual int __fastcall AddKey(TStrings *AsciiKey);
   // remove
   int __fastcall Delete(int Item);
   // utility
   virtual int __fastcall Find(BUFFER *KeyBuf);
   virtual int __fastcall Find(TPgpDBKey *Key);
   int __fastcall FindDescrip(AnsiString &Descrip);
   int __fastcall KeyCount();
   void __fastcall Clear();
   // cyberpunk only
   TStrings* __fastcall SaveToStringsCpkDesc(TStrings *Strings, TStrings *Clist);
   TStrings* __fastcall SaveToStringsCpk(TStrings *Strings, TStrings *CList);
   bool __fastcall GetShortAndAddress(AnsiString &UserIds, AnsiString &Short,
      AnsiString &Address, TStrings *Rlist);
};

const AnsiString PgpBeginPubKeyBlock = "-----BEGIN PGP PUBLIC KEY BLOCK-----";
const AnsiString PgpEndPubKeyBlock = "-----END PGP PUBLIC KEY BLOCK-----";
const AnsiString PgpBeginSecKeyBlock = "-----BEGIN PGP SECRET KEY BLOCK-----";
const AnsiString PgpEndSecKeyBlock = "-----END PGP SECRET KEY BLOCK-----";
const bool Armored = true;
#endif
